#include "Main.h"
#include "MCP2515.h"
#include "SPI.h"
#include "REGS2515.h"

unsigned char CAN_TX_Buf[13] = { 0x12,0xff,0x00,0x00,0x08,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88 };
unsigned char CAN_RX_Buf[13] = { 0x0 };
unsigned char CANRxFlag = 0;

volatile unsigned char temp = 0x0;

/*----------------------------------------------------------------------*\
 * Function    :MCP2515Init()
 * Description :Initilize MCP2515
 * Parameters  :None
 * Returns     :None
\*----------------------------------------------------------------------*/
void MCP2515Init( void )
{
//	unsigned char dummy,i;

    	MCP2515Reset();                                      				// CAN(MCP2515)λ
    	DelayMs( 1 );													// ʱ
   	MCP2515BitModify( CANCTRL,0xe0,REQOP_CONFIG );					// κģʽģʽ
	
	while( (MCP2515ByteRead( CANSTAT )&0xE0) != REQOP_CONFIG)			// ѯǷģʽ
	{	
		MCP2515BitModify( CANCTRL, 0xe0, REQOP_CONFIG );			     // ½ģʽ
		DelayMs( 10 );
	}
												// ģʽ֮ ܶCNF123޸
	MCP2515ByteWrite( CNF1, CAN_125kbps );							// òλ125Kbps
	MCP2515ByteWrite( CNF2, 0x80|PHSEG1_3TQ|PRSEG_1TQ );
	MCP2515ByteWrite( CNF3, PHSEG2_3TQ );							// PHSEG2_3TQ	

 	MCP2515ByteWrite( RXB0CTRL, 0X60);                                            //11 = رΣ˲ܣб
 	MCP2515ByteWrite( RXB0CTRL, 0X60); 
 	
 	MCP2515ByteWrite( CANINTF, 0X00 );
 	MCP2515ByteWrite( CANINTE, 0X01 );
 	
 	MCP2515BitModify( CANCTRL, 0xe0, REQOP_NORMAL );
 	
 	while( MCP2515ByteRead( CANSTAT )&0xE0 != REQOP_NORMAL )	 
	{
		MCP2515BitModify( CANCTRL, 0xE0, REQOP_NORMAL );  
		DelayMs( 10 );
	}
	
 /*
	MCP2515ByteWrite( TXRTSCTRL, 0x01 );								// ŵķ
	MCP2515ByteWrite( BFPCTRL, 0 );									// ŵĽжϹ
	
	MCP2515ByteWrite( RXM0SIDH, 0xFF );	
	MCP2515ByteWrite( RXM0SIDL, 0xE0 );	 
	
	MCP2515ByteWrite( RXF0SIDH, 0x00 );	 
	MCP2515ByteWrite( RXF0SIDL, 0x20 );	 
	MCP2515ByteWrite( RXB0CTRL, 0x60 );
	MCP2515ByteWrite( CANINTF, 0x00 );
 	MCP2515ByteWrite( CANINTE, 0x01 );
 
 	MCP2515BitModify( CANCTRL, 0x60, REQOP_NORMAL );
//	MCP2515_INT_Init(); 

	while( MCP2515ByteRead( CANSTAT )&0xE0 != REQOP_NORMAL )	 
	{
		MCP2515BitModify( CANCTRL, 0xE0, REQOP_NORMAL );  
		DelayMs( 10 );
	}	
		
	asm("nop");
	asm("nop");
	
*/	
/*	while(1); 
	
    //Clear masks to RX all messages
    MCP2515ByteWrite( RXM0SIDH, 0x00 );							    
    MCP2515ByteWrite( RXM0SIDL, 0x00 );

    //Clear filter... really only concerned to clear EXIDE bit
    MCP2515ByteWrite( RXF0SIDL, 0x00 );

    //Set CNF1
    MCP2515ByteWrite( CNF1, CAN_125kbps );

    //Set CNF2
    MCP2515ByteWrite( CNF2, 0x80 | PHSEG1_3TQ | PRSEG_1TQ );

    //Set CNF3
    MCP2515ByteWrite( CNF3, PHSEG2_3TQ );

    //Set TXB0 DLC and Data for a "Write Register" Input Message to the MCP25020
    MCP2515ByteWrite( TXB0SIDH, 0xA0 );    //Set TXB0 SIDH
    MCP2515ByteWrite( TXB0SIDL, 0x00 );    //Set TXB0 SIDL
    MCP2515ByteWrite( TXB0DLC, DLC_3);    //Set DLC = 3 bytes
    MCP2515ByteWrite( TXB0D0, 0x1E );      //D0 = Addr = 0x1E
    MCP2515ByteWrite( TXB0D1, 0x10 );      //D1 = Mask = 0x10

    //Set TXB1 DLC and Data for a "READ I/O IRM"
    MCP2515ByteWrite( TXB1SIDH, 0x50 );    //Set TXB0 SIDH
    MCP2515ByteWrite( TXB1SIDL, 0x00 );    //Set TXB0 SIDL
    MCP2515ByteWrite( TXB1DLC, 0x40 | DLC_8 );    //Set DLC = 3 bytes and RTR bit

    //Interrupt on RXB0 - CANINTE
    MCP2515ByteWrite( CANINTE, 0x01 );    //

    //Set NORMAL mode
     MCP2515ByteWrite( CANCTRL, REQOP_NORMAL | CLKOUT_ENABLED );

    //Verify device entered Normal mode
    dummy = MCP2515ByteRead( CANSTAT );

    if ( OPMODE_NORMAL != (dummy && 0xE0) )
        MCP2515ByteWrite( CANCTRL,REQOP_NORMAL | CLKOUT_ENABLED );
*/
}

//-----------------------------------------------------------------------------
//  SPIReset()
//-----------------------------------------------------------------------------
void MCP2515Reset( void )
{
	nRST = 0;
	_nop_();
	_nop_();
	nRST = 1;
	_nop_();
	_nop_();
    nCS = 0;;  //
	WriteSPIByte( CAN_RESET );
    nCS = 1;
}

//-------------------------------------------------------------------------
//  SPIByteWrite()
//-------------------------------------------------------------------------
void MCP2515ByteWrite( unsigned char addr, unsigned char value )
{
    nCS = 0;  //
    WriteSPIByte( CAN_WRITE );
    WriteSPIByte( addr );
    WriteSPIByte( value );
    nCS = 1;
}


//-----------------------------------------------------------------------------
//  SPIByteRead()
//-----------------------------------------------------------------------------
unsigned char MCP2515ByteRead(unsigned char addr)
{
    unsigned char tempdata;

	nCS = 0;  //
    WriteSPIByte( CAN_READ );
    WriteSPIByte(addr);
    tempdata = ReadSPIByte();
    nCS = 1;

    return tempdata;
}

//-----------------------------------------------------------------------------
//  CAN Bit-Modify
//-----------------------------------------------------------------------------
void MCP2515BitModify( unsigned char addr,unsigned char mask,unsigned char udata)
{
	unsigned char i;
	
     nCS = 0;
     for(i = 10;i > 0;i--) ;       
     
     WriteSPIByte( CAN_BIT_MODIFY );     
     WriteSPIByte( addr );
     WriteSPIByte( mask );
     WriteSPIByte( udata );
     
     nCS = 1;
}
//-----------------------------------------------------------------------------
//  RTS(buffer)
//	buffer = CAN_RTS_TXBn; where 'n' = 0, 1, 2
//	buffer = CAN_RTS; followed by | 0 - 7 (e.g., CAN_RTS | 7)
//-----------------------------------------------------------------------------
void MCP2515RTS( unsigned char buffer )
{
    unsigned char tempdata;

	tempdata = MCP2515ByteRead( CAN_RD_STATUS );

	if( buffer & 0x01 )                                                 //Buffer 0
		if( tempdata & 0x04 )                                           //Check TXREQ first
		{
			DelayMs( 1 );
			MCP2515ByteWrite( TXB0CTRL, 0 );                            //Clear TXREQ (and everything else... not clean)
			while( MCP2515ByteRead( CAN_RD_STATUS ) & 0x04 );           //Wait for TXREQ to clear
        }
	if( buffer & 0x02 )                                                 //Buffer 1
		if( tempdata & 0x10 )                                           //Check TXREQ first
		{
  			DelayMs( 1 );
            	MCP2515ByteWrite( TXB1CTRL, 0 );                            //Clear TXREQ (and everything else... not clean)
			while( MCP2515ByteRead( CAN_RD_STATUS ) & 0x10 );           //Wait for TXREQ to clear
		}
	if( buffer & 0x04 )                                                 //Buffer 2
		if( tempdata & 0x40 )                                           //Check TXREQ first
		{
  			DelayMs( 1 );
            	MCP2515ByteWrite( TXB2CTRL, 0 );                            //Clear TXREQ (and everything else... not clean)
			while( MCP2515ByteRead(CAN_RD_STATUS) & 0x40 );             //Wait for TXREQ to clear
		}

    	nCS = 0;
	WriteSPIByte( buffer );
	nCS = 1;
}

void CANSend( unsigned char *CAN_TX_Buf )
{	
	
	MCP2515ByteWrite( TXB0CTRL, 0x03 );
  
	MCP2515ByteWrite( TXB0SIDH,CAN_TX_Buf[0] );
	MCP2515ByteWrite( TXB0SIDL,CAN_TX_Buf[1] );
	MCP2515ByteWrite( TXB0EID8,CAN_TX_Buf[2] );
	MCP2515ByteWrite( TXB0EID0,CAN_TX_Buf[3] );
	
	MCP2515ByteWrite( TXB0DLC, CAN_TX_Buf[4] );
	
	MCP2515ByteWrite( TXB0D0, CAN_TX_Buf[5] );	 
	MCP2515ByteWrite( TXB0D1, CAN_TX_Buf[6] );
	MCP2515ByteWrite( TXB0D2, CAN_TX_Buf[7] );
	MCP2515ByteWrite( TXB0D3, CAN_TX_Buf[8] );
	MCP2515ByteWrite( TXB0D4, CAN_TX_Buf[9] );
	MCP2515ByteWrite( TXB0D5, CAN_TX_Buf[10] );
	MCP2515ByteWrite( TXB0D6, CAN_TX_Buf[11] );
	MCP2515ByteWrite( TXB0D7, CAN_TX_Buf[12] );

	MCP2515RTS( CAN_RTS_TXB0 );
}

void CANReceive( unsigned char * CAN_RX_Buf )
{
	unsigned char i;
	
		CAN_RX_Buf[0] = MCP2515ByteRead( RXB0SIDH );
    	CAN_RX_Buf[1] = MCP2515ByteRead( RXB0SIDL );
    	CAN_RX_Buf[2] = MCP2515ByteRead( RXB0EID8 );
    	CAN_RX_Buf[3] = MCP2515ByteRead( RXB0EID0 );

    	CAN_RX_Buf[4] = MCP2515ByteRead( RXB0DLC );
    	
    	for( i=0; i<CAN_RX_Buf[4]; i++ )
    	{
		CAN_RX_Buf[5+i] = MCP2515ByteRead( RXB0D0+i );    	
    	} 
}
