#ifndef __MCP2515_H__
#define __MCP2515_H__

#include <reg52.h>

//===========================================================================
//---------------------- Globle defines, variables  -------------------------
//===========================================================================
//MCP2515 Interface Config

sbit nRST = P1^3;
sbit nCS = P1^4;
sbit mSO = P1^5;
sbit mSI = P1^6;
sbit mSCK = P1^7;
sbit nINT = P3^3;


#define Mode00          0
#define Mode11          1

#define CAN_500kbps     1       //BRP setting in CNF1
#define CAN_250kbps     3       //Based on 16 MHz Fosc
#define CAN_125kbps     7       //

//#define CAN_RECEIVE_RENDERING
#define CAN_RECEIVE_INTERRUPT

extern unsigned char CAN_TX_Buf[13];
extern unsigned char CAN_RX_Buf[13];
extern unsigned char CANRxFlag;

extern volatile unsigned char temp;
//===========================================================================
//---------------------------Globle functions  ------------------------------
//===========================================================================
//extern void MCP2515InterfaceConfig( void );
extern void MCP2515Init( void );
extern void MCP2515Reset( void );
extern void MCP2515ByteWrite( unsigned char, unsigned char );
extern unsigned char MCP2515ByteRead(unsigned char );
extern void MCP2515RTS( unsigned char );
extern void MCP2515BitModify( unsigned char,unsigned char,unsigned char );

extern void CANSend( unsigned char * );
extern void CANReceive( unsigned char * );

#endif

