#include "MCP2515.h"
#include "SPI.h"

/*----------------------------------------------------------------*\
 * Function    : WriteSPIByte()
 * Description : Write byte to SPI
 * Parameters  : Byte
 * Returns     : None
\*--------------------------------------------=====---------------*/
void WriteSPIByte( unsigned char DataOut )
{
	unsigned char n;

	mSCK = 0;                               		// Make sure clock is low
    	_nop_();
		_nop_();
    	
    	for( n=0; n<8; n++ )
    	{
     	mSCK = 0;
		_nop_(); 
		_nop_();                          		//
	
        	if( DataOut&0x80 )          			// Clock a 1 0xFE
        		mSO = 1;
        	else                                	// Clock a 0
            	mSO = 0;
            	
		_nop_();
		_nop_();
		DataOut <<= 1;
		_nop_();
		_nop_();

        	mSCK = 1;                           		// Pulse clock
        	_nop_();
        	_nop_();
	}
}

/*-----------------------------------------------------------*\
 * Function    : ReadSPIByte
 * Description : Receive a Byte from SPI
 * Parameters  : None
 * Returns     : Byte Received
\*-----------------------------------------------------------*/
unsigned char ReadSPIByte( void )
{
	unsigned char n = 8;
	unsigned char DataIn = 0x0;
	
	mSCK = 0;                               //Make sure clock is low	
	_nop_();
	_nop_();
	
    	while( n-- )
    	{
        	mSCK = 1;
			_nop_();
			_nop_();
        	
        	DataIn <<= 1;
			_nop_();
			_nop_();
        	
        	if( mSI )
        		DataIn += 1;
			_nop_();
			_nop_();
        	
        	mSCK = 0;
        	_nop_();
        	_nop_();
    	}

    return DataIn;
}

